/*! \file */
/*******************************************
 *                                         *
 *  File auto-generated by `::safer_ffi`.  *
 *                                         *
 *  Do not manually edit this file.        *
 *                                         *
 *******************************************/

#ifndef __RUST_OXYD_GO__
#define __RUST_OXYD_GO__

#ifdef __cplusplus
extern "C" {
#endif


#include <stddef.h>
#include <stdint.h>

/** \brief
 *  Same as [`Vec<T>`][`rust::Vec`], but with guaranteed `#[repr(C)]` layout
 */
typedef struct Vec_uint8 {

    uint8_t * ptr;

    size_t len;

    size_t cap;

} Vec_uint8_t;

typedef struct Keypair {

    Vec_uint8_t secret_key;

    Vec_uint8_t public_key;

} Keypair_t;

Keypair_t generate_keypair (void);

Vec_uint8_t sign_data (
    Vec_uint8_t secret_key,
    Vec_uint8_t data);

Vec_uint8_t recover_public_key (
    Vec_uint8_t signature,
    Vec_uint8_t data);


#include <stdbool.h>

typedef struct CheckResult {

    bool is_valid;

    Vec_uint8_t message;

} CheckResult_t;

CheckResult_t check_signature (
    Vec_uint8_t public_key,
    Vec_uint8_t signature,
    Vec_uint8_t data);

Vec_uint8_t base64_encode (
    Vec_uint8_t data);

Vec_uint8_t base64_decode (
    Vec_uint8_t data);


#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* __RUST_OXYD_GO__ */
